import { __awaiter, __decorate } from "tslib";
import { FASTElement, customElement, observable } from '@microsoft/fast-element';
import { Container, inject, Registration } from '@microsoft/fast-foundation';
import { DefaultRouteRecognizer } from '@microsoft/fast-router';
import * as Components from '../components';
import { MainRouterConfig } from '../routes';
import { logger } from '../utils';
import { MainStyles as styles } from './main.styles';
import { MainTemplate as template } from './main.template';
const name = 'foundation-settings';
let MainApplication = class MainApplication extends FASTElement {
    constructor() {
        super(...arguments);
        this.ready = false;
    }
    connectedCallback() {
        this.container.register(Registration.transient(DefaultRouteRecognizer, DefaultRouteRecognizer));
        super.connectedCallback();
        logger.debug(`${name} is now connected to the DOM`);
        this.loadRemotes();
    }
    loadRemotes() {
        return __awaiter(this, void 0, void 0, function* () {
            const remoteComponents = yield Components.loadRemotes({});
            this.ready = true;
        });
    }
    providerChanged() {
    }
};
__decorate([
    inject(MainRouterConfig)
], MainApplication.prototype, "config", void 0);
__decorate([
    Container
], MainApplication.prototype, "container", void 0);
__decorate([
    observable
], MainApplication.prototype, "provider", void 0);
__decorate([
    observable
], MainApplication.prototype, "ready", void 0);
MainApplication = __decorate([
    customElement({
        name,
        template,
        styles,
    })
], MainApplication);
export { MainApplication };
